/*******************************************************************************
 * FoxSceneCaptureActor generated by Eliot.UELib using UE Explorer.
 * Eliot.UELib ? 2009-2015 Eliot van Uytfanghe. All rights reserved.
 * http://eliotvu.com
 *
 * All rights belong to their respective owners.
 *******************************************************************************/
class FoxSceneCaptureActor extends SceneCapture2DActor
    native(Camera)
    hidecategories(Navigation);

enum ERenderItemType
{
    ERIT_GearProvider,
    ERIT_Body,
    ERIT_BodyCamo,
    ERIT_WeaponCamo,
    ERIT_Weapon,
    ERIT_Depot,
    ERIT_MAX
};

struct native CaptureInfo
{
    var Texture2D TextureCapture;
    var int UnlockID;
    var bool bRenderCaptured;
    var bool bSaveRender;
    var FoxSceneCaptureActor.ERenderItemType ItemType;
    var FoxDataProvider_Unlockable DataProvider;
    var FoxWeaponConfigInfo WeaponInfo;
    var FoxDepotPresetInfo DepotInfo;
    var ProfileGearInfo GearInfo;
    var int CustomItemType;

    structdefaultproperties
    {
        TextureCapture=none
        UnlockID=0
        bRenderCaptured=false
        bSaveRender=false
        ItemType=ERenderItemType.ERIT_GearProvider
        DataProvider=none
        WeaponInfo=(WeaponSkin=255,WeaponClass=none,WeaponMuzzle=255,WeaponStock=none,WeaponBarrel=none,WeaponMagazine=255,WeaponScope=none,WeaponHanger=0,WeaponGrip=none,WeaponAmmo=none,WeaponCamoIndex=0)
        DepotInfo=(ItemType="",ItemClass="",Cost=0,EffectAmount=0,Wpn="",Muz="",Sto="",Bar="",Mag="",Sco="",GRI="",Amm="",UnlockID=0,ParentID=0,NameID="",ImageIconRef="",NameLocSectionName="DepotPresets",DescLocSectionName="DepotPresetsDesc",TagLocSectionName="DepotPresetsTag",TooltipLocSectionName="DepotPresetsToolTip")
        GearInfo=(BodyCamoID=255,UpperBodyID=255,LowerBodyID=255,HelmetID=255,BadgeID=0,Gear_R1ID=255,Gear_R2ID=255,Gear_L1ID=255,Gear_L2ID=255,TacticalID=255,ButtPackID=255,bFemale=false,bBot=false,AvatarID=-1,PatchIconID=0,PatchIconColorID=255,PatchShapeID=255,PatchShapeColorID=255,HangerID=-1)
        CustomItemType=0
    }
};

var() name ViewName;
var transient bool bPictureReady;
var transient array<CaptureInfo> RenderQueue;
var transient array<CaptureInfo> CaptureList;
var() FoxPreviewSpawnPoint SpawnPoint;
var() export editinline StaticMeshComponent MyStaticMeshComponent;
var() export editinline SkeletalMeshComponent MySkeletalMeshComponent;
var() FoxCustomActor PreviewActor;
var Texture2D BlankTexture;
var delegate<OnRenderCaptured> __OnRenderCaptured__Delegate;

delegate OnRenderCaptured(int ScrollerIndex, string IconPath)
{
    //return;    
}

// Export UFoxSceneCaptureActor::execAddGearProviderToQueue(FFrame&, void* const)
native function string AddGearProviderToQueue(FoxDataProvider_GearInfo GearInfo, int NewCustomItemType);

// Export UFoxSceneCaptureActor::execAddBodyGearInfoToQueue(FFrame&, void* const)
native function string AddBodyGearInfoToQueue(ProfileGearInfo NewGearInfo, int NewCustomItemType, int UnlockID);

// Export UFoxSceneCaptureActor::execAddWeaponConfigToQueue(FFrame&, void* const)
native function string AddWeaponConfigToQueue(FoxWeaponConfigInfo NewWeaponInfo, int NewCustomItemType, int UnlockID);

// Export UFoxSceneCaptureActor::execAddCamoToQueue(FFrame&, void* const)
native function string AddCamoToQueue(int NewCamoIndex, bool bWeaponCamo, int UnlockID);

// Export UFoxSceneCaptureActor::execAddDepotItemToQueue(FFrame&, void* const)
native function string AddDepotItemToQueue(FoxDepotPresetInfo DepotPreset);

event SetBodyCamoBox(int CamoIndex)
{
    MySkeletalMeshComponent.SetSkeletalMesh(skeletalmesh'Sk_BLBox');
    SetMeshBodyCamo(MySkeletalMeshComponent, CamoIndex);
    MySkeletalMeshComponent.SetHidden(false);
    PositionMeshToCapture(MySkeletalMeshComponent);
    //return;    
}

event SetBodyMesh(ProfileGearInfo GearInfo, int NewCustomItemType)
{
    local Vector NewLocation;
    local Rotator NewRotation;

    // End:0x7F
    if(FoxCustomPlayerActor(PreviewActor) == none)
    {
        // End:0x3F
        if(PreviewActor != none)
        {
            PreviewActor.Destroy();
        }
        PreviewActor = Spawn(class'FoxCustomPlayerActor', self,, SpawnPoint.Location);
    }
    FoxCustomPlayerActor(PreviewActor).UpdateGearInfo(GearInfo);
    // End:0x144
    if(FoxCustomPlayerActor(PreviewActor).IdleAnimName != 'Armory_Idle_A')
    {
        FoxCustomPlayerActor(PreviewActor).IdleAnimName = 'Armory_Idle_A';
        FoxCustomPlayerActor(PreviewActor).StartIdleAnimation(0.0);
    }
    PreviewActor.CustomItemType = NewCustomItemType;
    PreviewActor.bValidLocation = false;
    PreviewActor.PreviewFOV = 60.0;
    PreviewActor.MoveWeaponToIdealPosition(0.0, 0.0, 1280.0, 720.0);
    switch(NewCustomItemType)
    {
        // End:0x25C
        case 4:
            PreviewActor.CameraOffset.Z += float(65);
            PreviewActor.CameraDistance /= 3.50;
            // End:0x323
            break;
        // End:0x2C0
        case 3:
            PreviewActor.CameraOffset.Z += float(5);
            PreviewActor.CameraDistance /= 5.0;
            // End:0x323
            break;
        // End:0x2FB
        case 0:
            PreviewActor.CameraOffset.Z += float(10);
        // End:0xFFFF
        default:
            PreviewActor.CameraDistance /= 2.50;
            NewLocation = SpawnPoint.Location;
            NewRotation = PreviewActor.FinishedRotation;
            NewLocation += (PreviewActor.RotatedOffset >> NewRotation);
            NewLocation += PreviewActor.CameraOffset;
            NewLocation -= (vector(NewRotation) * PreviewActor.CameraDistance);
            SceneCapture2DComponent(SceneCapture).SetView(NewLocation, NewRotation);
            SetLocation(NewLocation);
            SetRotation(NewRotation);
            //return;
    }    
}

event SetGearMesh(FoxDataProvider_GearInfo GearInfoProvider)
{
    local StaticMesh NewStaticMesh;
    local SkeletalMesh NewSkeletalMesh;
    local FoxWeaponConfigInfo WeaponInfo;
    local FoxDataProvider_Gear_Attachment GearInfo;

    // End:0x2F
    if(MyStaticMeshComponent != none)
    {
        MyStaticMeshComponent.SetHidden(true);
    }
    // End:0x5E
    if(MySkeletalMeshComponent != none)
    {
        MySkeletalMeshComponent.SetHidden(true);
    }
    GearInfo = FoxDataProvider_Gear_Attachment(GearInfoProvider);
    // End:0x148
    if(GearInfo.WeaponClassName != "")
    {
        // End:0xCE
        if(PreviewActor != none)
        {
            PreviewActor.SetHidden(false);
        }
        WeaponInfo.WeaponClass = class<FoxWeapon>(class'FoxLoadoutInfo'.static.ResolveWpnContentByName(GearInfo.WeaponClassName));
        SetWeaponActor(WeaponInfo, 1);
    }
    // End:0x3C8
    else
    {
        // End:0x1AA
        if(PreviewActor != none)
        {
            // End:0x192
            if(FoxCustomWeaponActor(PreviewActor) != none)
            {
                PreviewActor.SetHidden(true);
            }
            // End:0x1AA
            else
            {
                PreviewActor.Destroy();
            }
        }
        SceneCapture2DComponent(SceneCapture).SetView(SpawnPoint.Location, SpawnPoint.Rotation);
        SetLocation(SpawnPoint.Location);
        SetRotation(SpawnPoint.Rotation);
        NewSkeletalMesh = GearInfo.GetSkelMeshAsset(false, none);
        // End:0x315
        if(NewSkeletalMesh != none)
        {
            MySkeletalMeshComponent.SetSkeletalMesh(NewSkeletalMesh);
            MySkeletalMeshComponent.SetHidden(false);
            PositionMeshToCapture(MySkeletalMeshComponent);
            MySkeletalMeshComponent.SetRotation(rot(0, 32768, 0));
        }
        // End:0x3C8
        else
        {
            NewStaticMesh = GearInfo.GetStaticMeshAsset(false, none);
            MyStaticMeshComponent.SetStaticMesh(NewStaticMesh);
            MyStaticMeshComponent.SetHidden(false);
            MyStaticMeshComponent.SetRotation(rot(0, 16384, 0));
            PositionMeshToCapture(MyStaticMeshComponent);
        }
    }
    //return;    
}

event SetDepotActor(out FoxDepotPresetInfo NewPresetInfo)
{
    local FoxWeaponConfigInfo WeaponConfig;
    local Vector NewLocation;
    local Rotator NewRotation, BaseRotation;

    // End:0x93
    if(NewPresetInfo.NameID ~= "Health")
    {
        // End:0x50
        if(PreviewActor != none)
        {
            PreviewActor.Destroy();
        }
        PreviewActor = Spawn(class'FoxCustomHealthActor', self,, SpawnPoint.Location);
    }
    // End:0x59B
    else
    {
        // End:0x13B
        if(NewPresetInfo.NameID ~= "Ammo")
        {
            // End:0xE1
            if(PreviewActor != none)
            {
                PreviewActor.Destroy();
            }
            PreviewActor = Spawn(class'FoxCustomAmmoActor', self,, SpawnPoint.Location);
            NewRotation = rot(-4096, 32768, 0);
        }
        // End:0x59B
        else
        {
            // End:0x1D1
            if(NewPresetInfo.NameID ~= "DepotAmmo")
            {
                // End:0x18E
                if(PreviewActor != none)
                {
                    PreviewActor.Destroy();
                }
                PreviewActor = Spawn(class'FoxCustomHeavyRefillActor', self,, SpawnPoint.Location);
            }
            // End:0x59B
            else
            {
                // End:0x26D
                if(NewPresetInfo.NameID ~= "WpnPreset_DPT_0")
                {
                    // End:0x22A
                    if(PreviewActor != none)
                    {
                        PreviewActor.Destroy();
                    }
                    PreviewActor = Spawn(class'FoxCustomTurretActor', self,, SpawnPoint.Location);
                }
                // End:0x59B
                else
                {
                    // End:0x320
                    if(NewPresetInfo.NameID ~= "WpnPreset_HST_0")
                    {
                        // End:0x2C6
                        if(PreviewActor != none)
                        {
                            PreviewActor.Destroy();
                        }
                        PreviewActor = Spawn(class'FoxCustomHardSuitActor', self,, SpawnPoint.Location);
                        BaseRotation = rot(3072, 7168, 0);
                    }
                    // End:0x59B
                    else
                    {
                        // End:0x3D2
                        if(NewPresetInfo.NameID ~= "WpnPreset_DP_0")
                        {
                            // End:0x378
                            if(PreviewActor != none)
                            {
                                PreviewActor.Destroy();
                            }
                            PreviewActor = Spawn(class'FoxCustomPlayerActor', self,, SpawnPoint.Location);
                            BaseRotation = rot(3072, 7168, 0);
                        }
                        // End:0x59B
                        else
                        {
                            class'FoxUnlockInfo'.static.GetDepotPresetClasses(NewPresetInfo, WeaponConfig.WeaponClass, WeaponConfig.WeaponBarrel, WeaponConfig.WeaponMuzzle, WeaponConfig.WeaponScope, WeaponConfig.WeaponStock, WeaponConfig.WeaponMagazine, WeaponConfig.WeaponGrip, WeaponConfig.WeaponAmmo);
                            // End:0x501
                            if(PreviewActor != none)
                            {
                                PreviewActor.Destroy();
                            }
                            PreviewActor = Spawn(class'FoxCustomWeaponActor', self,, SpawnPoint.Location);
                            FoxCustomWeaponActor(PreviewActor).UpdateConfigInfo(WeaponConfig);
                            FoxCustomWeaponActor(PreviewActor).CustomItemType = 1;
                        }
                    }
                }
            }
        }
    }
    PreviewActor.bValidLocation = false;
    PreviewActor.MoveWeaponToIdealPosition(0.0, 0.0, 1280.0, 720.0, BaseRotation);
    NewLocation = SpawnPoint.Location;
    NewRotation += PreviewActor.FinishedRotation;
    NewLocation += (PreviewActor.RotatedOffset >> NewRotation);
    NewLocation += PreviewActor.CameraOffset;
    NewLocation -= (vector(NewRotation) * PreviewActor.CameraDistance);
    SceneCapture2DComponent(SceneCapture).SetView(NewLocation, NewRotation);
    SetLocation(NewLocation);
    SetRotation(NewRotation);
    //return;    
}

event SetWeaponActor(out FoxWeaponConfigInfo NewWeaponInfo, int NewCustomItemType)
{
    local Vector NewLocation;
    local Rotator NewRotation;

    // End:0x7F
    if(FoxCustomWeaponActor(PreviewActor) == none)
    {
        // End:0x3F
        if(PreviewActor != none)
        {
            PreviewActor.Destroy();
        }
        PreviewActor = Spawn(class'FoxCustomWeaponActor', self,, SpawnPoint.Location);
    }
    FoxCustomWeaponActor(PreviewActor).UpdateConfigInfo(NewWeaponInfo);
    PreviewActor.CustomItemType = NewCustomItemType;
    PreviewActor.bValidLocation = false;
    PreviewActor.PreviewFOV = 60.0;
    PreviewActor.MoveWeaponToIdealPosition(0.0, 0.0, 1280.0, 720.0);
    NewLocation = SpawnPoint.Location;
    NewRotation = PreviewActor.FinishedRotation;
    NewLocation += (PreviewActor.RotatedOffset >> NewRotation);
    NewLocation += PreviewActor.CameraOffset;
    NewLocation -= (vector(NewRotation) * PreviewActor.CameraDistance);
    SceneCapture2DComponent(SceneCapture).SetView(NewLocation, NewRotation);
    SetLocation(NewLocation);
    SetRotation(NewRotation);
    //return;    
}

function HideAnyPreviewMeshes()
{
    // End:0x2F
    if(MyStaticMeshComponent != none)
    {
        MyStaticMeshComponent.SetHidden(true);
    }
    // End:0x5E
    if(MySkeletalMeshComponent != none)
    {
        MySkeletalMeshComponent.SetHidden(true);
    }
    //return;    
}

event CleanUpPreviewActors()
{
    // End:0x27
    if(PreviewActor != none)
    {
        PreviewActor.Destroy();
    }
    HideAnyPreviewMeshes();
    //return;    
}

function ClearCaptureList()
{
    // End:0x2F
    if(MyStaticMeshComponent != none)
    {
        MyStaticMeshComponent.SetHidden(true);
    }
    bPictureReady = false;
    RenderQueue.Length = 0;
    CaptureList.Length = 0;
    //return;    
}

// Export UFoxSceneCaptureActor::execSetRenderUnlocks(FFrame&, void* const)
native function SetRenderUnlocks(array<int> UnlocksToRender, delegate<OnRenderCaptured> RenderCompleteDelegate, optional bool bSaveRender)
{
    bSaveRender = true;                    
}

// Export UFoxSceneCaptureActor::execPositionMeshToCapture(FFrame&, void* const)
native function PositionMeshToCapture(MeshComponent MeshComp);

// Export UFoxSceneCaptureActor::execSetMeshBodyCamo(FFrame&, void* const)
native function SetMeshBodyCamo(MeshComponent MeshComponent, int CamoIndex);

// Export UFoxSceneCaptureActor::execSetupRenderTargetByUnlockID(FFrame&, void* const)
native function bool SetupRenderTargetByUnlockID(int UnlockID);

// Export UFoxSceneCaptureActor::execGetIconStringForUnlockID(FFrame&, void* const)
native function bool GetIconStringForUnlockID(int UnlockID, out string CurrentIconString);

defaultproperties
{
    begin object name=StaticMeshComponent0 class=StaticMeshComponent
        ReplacementPrimitive=none
        bCastStaticShadow=false
        bAcceptsDynamicDominantLightShadows=false
        AbsoluteTranslation=true
        bIgnoreMaxDrawDistance=true
        LightingChannels=(Cinematic_2=true)
    object end
    // Reference: StaticMeshComponent'Default__FoxSceneCaptureActor.StaticMeshComponent0'
    MyStaticMeshComponent=StaticMeshComponent0
    begin object name=SkeletalMeshComponent0 class=SkeletalMeshComponent
        ReplacementPrimitive=none
        bCastStaticShadow=false
        bAcceptsDynamicDominantLightShadows=false
        AbsoluteTranslation=true
        bIgnoreMaxDrawDistance=true
        LightingChannels=(Cinematic_2=true)
    object end
    // Reference: SkeletalMeshComponent'Default__FoxSceneCaptureActor.SkeletalMeshComponent0'
    MySkeletalMeshComponent=SkeletalMeshComponent0
    begin object name=Texture2D0 class=Texture2D
        TextureFileCacheName=StartupTextures
    object end
    // Reference: Texture2D'Default__FoxSceneCaptureActor.Texture2D0'
    BlankTexture=Texture2D0
    begin object name=DrawFrust0 class=DrawFrustumComponent
        ReplacementPrimitive=none
    object end
    // Reference: DrawFrustumComponent'Default__FoxSceneCaptureActor.DrawFrust0'
    DrawFrustum=DrawFrust0
    begin object name=SceneCapture2DComponent0 class=SceneCapture2DComponent
        FarPlane=2000.0
        bEnabled=false
    object end
    // Reference: SceneCapture2DComponent'Default__FoxSceneCaptureActor.SceneCapture2DComponent0'
    SceneCapture=SceneCapture2DComponent0
    begin object name=SceneCapture2DComponent0 class=SceneCapture2DComponent
        FarPlane=2000.0
        bEnabled=false
    object end
    // Reference: SceneCapture2DComponent'Default__FoxSceneCaptureActor.SceneCapture2DComponent0'
    Components(0)=SceneCapture2DComponent0
    Components(1)=none
    begin object name=DrawFrust0 class=DrawFrustumComponent
        ReplacementPrimitive=none
    object end
    // Reference: DrawFrustumComponent'Default__FoxSceneCaptureActor.DrawFrust0'
    Components(2)=DrawFrust0
    begin object name=StaticMeshComponent0 class=StaticMeshComponent
        ReplacementPrimitive=none
        bCastStaticShadow=false
        bAcceptsDynamicDominantLightShadows=false
        AbsoluteTranslation=true
        bIgnoreMaxDrawDistance=true
        LightingChannels=(Cinematic_2=true)
    object end
    // Reference: StaticMeshComponent'Default__FoxSceneCaptureActor.StaticMeshComponent0'
    Components(3)=StaticMeshComponent0
    begin object name=SkeletalMeshComponent0 class=SkeletalMeshComponent
        ReplacementPrimitive=none
        bCastStaticShadow=false
        bAcceptsDynamicDominantLightShadows=false
        AbsoluteTranslation=true
        bIgnoreMaxDrawDistance=true
        LightingChannels=(Cinematic_2=true)
    object end
    // Reference: SkeletalMeshComponent'Default__FoxSceneCaptureActor.SkeletalMeshComponent0'
    Components(4)=SkeletalMeshComponent0
    RemoteRole=ENetRole.ROLE_None
}